/*
    pd̂߂̓dEdv Header File

        Copyrights 2009-2010, Yoshi Hiroshi
*/

// Rl̐ݒ
// Ȓl𗘗pƂ́A̒`Lɂ
//#define REGISTER_MESURED

#ifdef REGISTER_MESURED
// Rlݒ肷B
#define R14_R17     0.035   // 0.025
#define R18         299.4   // 330.0
#define R19         992.0   // 1000.0
#define R20         1994.0  // 2000.0
#define R21         816.0   // 820.0
#define R22         199.6   // 200.0
#define R23         61.8    // 62.0
#define R24         3870.0  // 3900.0
#define R26         1994.0  // 2000.0
#define R27         815.0   // 820.0
#define R28         9100.0  // 9100.0

#define R34         5590.0      // 5600.0
#define R35         14930.0     // 15000.0

#else
// RĺA݌vl𗘗p
#define R14_R17     0.035
#define R18         330.0
#define R19         1000.0
#define R20         2000.0
#define R21         820.0
#define R22         200.0
#define R23         62.0
#define R24         3900.0
#define R26         2000.0
#define R27         820.0
#define R28         9100.0

#define R34         5600.0
#define R35         15000.0

#endif


// ADCt@Xd

#define ADC_REF_5               4.997   // 5.0 

// dlvZpZ
#define VOLTAGE_CONV_FACTOR_1   (ADC_REF_5 * (R35 + R34) / R34)

// dlvZpZ
#define R19_18                  (1 / (1/R19 + 1/R18))
#define R21_20                  (1 / (1/R21 + 1/R20))
#define R22_20                  (1 / (1/R22 + 1/R20))
#define R23_20                  (1 / (1/R23 + 1/R20))
#define R24_20                  (1 / (1/R24 + 1/R20))
#define AMPERE_CONV_FACTOR_1    ((ADC_REF_5 * (R23_20/R26) * (R27/R28)) / R19)
#define AMPERE_CONV_FACTOR_2    ((ADC_REF_5 * (R22_20/R26) * (R27/R28)) / R19_18)
#define AMPERE_CONV_FACTOR_3    ((ADC_REF_5 * (R24_20/R26) * (R27/R28)) / R19_18)
#define AMPERE_CONV_FACTOR_4    ((ADC_REF_5 * (R23_20/R26) * (R27/R28)) / R14_R17)
#define AMPERE_CONV_FACTOR_5    ((ADC_REF_5 * (R22_20/R26) * (R27/R28)) / R14_R17)
#define AMPERE_CONV_FACTOR_6    ((ADC_REF_5 * (R21_20/R26) * (R27/R28)) / R14_R17)

// ADC `l
#define ADC_CHANNEL_VOLT        1
#define ADC_CHANNEL_RANGE       2
#define ADC_CHANNEL_CURR        3
#define AVERAGE_SIZE		    16


// dvW R[h
#define AMPERE_RANGE_10uA       0x31
#define AMPERE_RANGE_100uA      0x32
#define AMPERE_RANGE_1mA        0x33
#define AMPERE_RANGE_300mA      0x34
#define AMPERE_RANGE_1A         0x35
#define AMPERE_RANGE_3A         0x36

// foCXˑ̃JE^[`
#if defined (__AVR_ATmega8__)
#define SET_COMPA_REG(us)               OCR1A =((us) / (64 / (F_CPU/1000000L))) - 1 
#define SET_TCCR_A                      TCCR1A = 0
#define SET_TCCR_B                      TCCR1B = _BV(WGM12) | _BV(CS11) | _BV(CS10)
#define COUNTER_COMPARE_MATCH           (TIFR & _BV(OCF1A)) 
#define CLEAR_FLAG_COMPARE_MATCH        (TIFR |= _BV(OCF1A)) 

#elif defined (__AVR_ATtiny861__)
#define SET_COMPA_REG(us)               OCR0A =((us) / (256 / (F_CPU/1000000L))) - 1 
#define SET_TCCR_A                      TCCR0A = _BV(WGM00)
#define SET_TCCR_B                      TCCR0B = _BV(CS02)
#define COUNTER_COMPARE_MATCH           (TIFR & _BV(OCF0A)) 
#define CLEAR_FLAG_COMPARE_MATCH        (TIFR |= _BV(OCF0A)) 

#else
#define SET_COMPA_REG(us)               OCR1A =((us) / (64 / (F_CPU/1000000L))) - 1 
#define SET_TCCR_A                      TCCR1A = 0
#define SET_TCCR_B                      TCCR1B = _BV(WGM12) | _BV(CS11) | _BV(CS10)
#define COUNTER_COMPARE_MATCH           (TIFR1 & _BV(OCF1A)) 
#define CLEAR_FLAG_COMPARE_MATCH        (TIFR1 |= _BV(OCF1A)) 

#endif
